/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

/* 
 * File:   bme280.h
 * Author: pi
 *
 * Created on 2016/11/15, 15:36
 */

#ifndef BME280_H
#define BME280_H

#include "rpI2c.h"
#include <stdint.h>

#define ADDRESS 0x76

class CBme280 {
    int32_t m_fine;
    CI2C* m_pI2c;
    int16_t m_digT1;
    int16_t m_digT2;
    int16_t m_digT3;
    uint16_t m_digP1;
    int16_t m_digP2;
    int16_t m_digP3;
    int16_t m_digP4;
    int16_t m_digP5;
    int16_t m_digP6;
    int16_t m_digP7;
    int16_t m_digP8;
    int16_t m_digP9;
    int8_t m_digH1;
    int16_t m_digH2;
    int8_t m_digH3;
    int16_t m_digH4;
    int16_t m_digH5;
    int8_t m_digH6;


public:
    CBme280();
    ~CBme280();
    void init(CI2C* pI2c);
    double getTemparature();
    double getHumidity();
    double getPressure();

protected:
    void getTrim();
    bool setUp();
    double compensate_T(int32_t adc_T);
    double compensate_P(int32_t adc_P);
    double compensate_H(int32_t adc_H);
    signed long int calibration_T(signed long int adc_T);
    unsigned long int calibration_P(signed long int adc_P);
    unsigned long int calibration_H(signed long int adc_H);
};


#endif /* BME280_H */
