/*
 * I2C.h
 *
 *  Created on: 2014/05/29
 *      Author: sunaga
 */

#ifndef RP_I2C_H_
#define RP_I2C_H_

//#include <linux/i2c.h>
#include <linux/i2c-dev.h>
#include <stdint.h>

struct i2cVal {
    bool enable;
    int val;
};

class CI2C {
    int m_nFd;
    unsigned char m_bEnable;

    int SetSmbus(char rw, int command, int size, union i2c_smbus_data *data);
public:
    CI2C();
    ~CI2C();
    i2cVal Get8bits(int devAddr, int index);
    i2cVal Get16bits(int devAddr, int index);
    int Set8bits(int devAddr, int index, int value);
    int Set16bits(int devAddr, int index, int value);
    int SetBaudrate(int freq);
    int GetBaudrate();

    int GetFd() {
        return m_nFd;
    }
    int wakeUp(int devAddr, int cnt);
    int Write(int devAddr, char* pData, int size);
    int Read(int devAddr, uint8_t* pData, int size);

};


#endif /* RP_I2C_H_ */
